// Copyright 2007 Paul Milenkovic, 118 Shiloh Dr., Madison, WI 53705 U.S.A.

#ifndef EchoCancelH
#define EchoCancelH

#include "NonCausalP.h"

class EchoCancel : public NonCausalP
{
private: 
	int M;

protected:
	// dst contains 0 .. nSamp-1 samples of echo canceler target;
	// src contains 0 .. nSamp+M+M-1 of reference signal
	// (n ranging from [-M .. nSamp+M-1])
    virtual void Apply(float* src, float* dst, int nSamp) 
    {
        for (int i = 0; i < nSamp; i++)
            dst[i] -= src[M+i];
    }

public:
	EchoCancel() : M(0) {}

	virtual void  STDCALL Set_param_list(double* param_list, int nParam) 
	{
        if (nParam > 0)	
        {
            M = (int) param_list[0];
            if (M > 2048)
                M = 2048;
            setM_pre(M);
            setM_pst(M);
        }

	}
};

#endif
