// Copyright 2011 Paul Milenkovic, 118 Shiloh Dr., Madison, WI 53705 U.S.A.

#ifndef SumSourcesH
#define SumSourcesH

#include "NonCausalP.h"

class SumSources : public NonCausalP
{
private: 
	double G0, G1;

protected:
	// dst contains 0 .. nSamp-1 samples of echo canceler target;
	// src contains 0 .. nSamp+M+M-1 of reference signal
	// (n ranging from [-M .. nSamp+M-1])
    virtual void Apply(float* src, float* dst, int nSamp) 
    {
        for (int i = 0; i < nSamp; i++)
            dst[i] = G0*dst[i] + G1*src[i];
    }

public:
	SumSources() : G0(1.0), G1(1.0) {setM_pre(0); setM_pst(0);}

	virtual void  STDCALL Set_param_list(double* param_list, int nParam) 
	{
        if (nParam > 0)	{G0 = param_list[0];}
        if (nParam > 1)	{G1 = param_list[1];}
	}
};

#endif
